
/* BN.h
 * SBC++ (soccer client for Robocup2000)
 * Eslam Nazemi<nazemi@cc.sbu.ac.ir>
 * Amin Abbaspour<a-abbaspour@ce.sbu.ac.ir>
 * Mahmood Rahmani<m-rahmani@ce.sbu.ac.ir>
 * Bahman Radjabalipoor<b-radjabalipoor@ce.sbu.ac.ir>
 * Computer Department
 * Shahid Beheshti University
 */


#ifndef __BEHAVIOR_NETWORK_H
#define __BEHAVIOR_NETWORK_H

#include "NetHeader.h"
#include "ParsTools.h"
#include "NetParams.h"
#include "NetNodes.h"
#include "NetView.h"

class TBehaviorNetwork : public TNetworkParams,
			 public TNetworkView,
			 public TParseTools
{
    TCompetence *pComp;
    TGoal       *pGoal;

    int    iCompIndex;
    int    iGoalIndex;

    float  ResTh[MAX_RESOURCE], DefResTh[MAX_RESOURCE], DefResThRed[MAX_RESOURCE];

    void   RunAllGoals();
    void   PreExecuteNetwork();
    int    GetGoalNumOfComp(TCompetence aComp);
    void   ParseRuleFile();
    void   AdjustNetworkLinks();
    void   DoActivationSpreading();
    void   CalcCompExpect();

    void   DebugIt();
    void   DebugIt2();
    
    int    GetGoalFunc(const int& FuncNum);
    int    GetGoalNum (const int& FuncNum);

    inline float Goetz(const float& x) {
        return ( 1.0 / (1.0 + exp(GetK() * (GetMu() - x))) );
    }
    inline float H(const float& fAct, const float& fExec) {
        return (fAct * fExec);
    }

public:
    TBehaviorNetwork(const char *sFileName);
    ~TBehaviorNetwork();

    void ShowNetwork();
    void ExecuteNetwork(const int& iUnusedRes = -1);
};


#endif // __BEHAVIOR_NETWORK_H