
/* NetHeader.h
 * SBC++ (soccer client for Robocup2000)
 * Eslam Nazemi<nazemi@cc.sbu.ac.ir>
 * Amin Abbaspour<a-abbaspour@ce.sbu.ac.ir>
 * Mahmood Rahmani<m-rahmani@ce.sbu.ac.ir>
 * Bahman Radjabalipoor<b-radjabalipoor@ce.sbu.ac.ir>
 * Computer Department
 * Shahid Beheshti University
*/

#ifndef __NETWORK_HEADER_H
#define __NETWORK_HEADER_H

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "types.h"

#define DEFAULT_GAMA		0.5
#define DEFAULT_DELTA		0.2
#define DEFAULT_BETA		0.3

#define DEFAULT_MU   		0.5
#define DEFAULT_K   		1.0

#define FUZZY_BORDER            0.5

#define NEW_LINE                "\r\n"
#define STRING_IF               "IF"
#define STRING_AND              "AND"
#define STRING_THEN             "THEN"
#define STRING_EFFECT           "EFFECT"
#define STRING_NOT              "NOT"
#define STRING_USING            "USING"
#define STRING_END_IF           "ENDIF"
#define STRING_GOAL             "GOAL"
#define STRING_END_GOAL         "ENDGOAL"

#define STRING_LEG              "leg"
#define STRING_MOUTH            "mouth"
#define STRING_NECK             "neck"

#define GOALIE_RULE		"goalie.rul"
#define DEFENDER_RULE		"defender.rul"
#define MIDFIELDER_DEF_RULE	"midfielder.def.rul"
#define MIDFIELDER_OFF_RULE	"midfielder.off.rul"
#define OFFENDER_RULE		"offender.rul"

#define COMMANDS_LIST_FILE	"clist.lst"
#define BEHAVES_LIST_FILE	"blist.lst"
	

#define	RESOURCE_LEG            0
#define	RESOURCE_NECK           1
#define	RESOURCE_MOUTH          2
#define MAX_RESOURCE		3

#define BLOCK_COMPETENCE        0
#define BLOCK_GOAL		1
#define BLOCK_UNKOWN	        2

#define MaxEffects		10
#define MaxPreConditions        10
#define MaxExpantions           15

#define MaxGoals		10

#define ParseBlockMaxLength	40
#define STRLEN 			60

#define MaxReExecute		3

#ifdef  DEBUG_OUTPUT
#define DEBUG(x) x
#else
#define DEBUG(x) 
#endif

#define min(x, y)		x > y ? y : x 
#define max(x, y)		x > y ? x : y 

void  	up(char *s);
void  	down(char *s);
float 	rnd();
void    tick();
float   getnot(float val);
void    not(float& val);
Bool    IsTrue(float val);

#endif // __NETWORK_HEADER_H