
/* NetParams.h
 * SBC++ (soccer client for Robocup2000)
 * Eslam Nazemi<nazemi@cc.sbu.ac.ir>
 * Amin Abbaspour<a-abbaspour@ce.sbu.ac.ir>
 * Mahmood Rahmani<m-rahmani@ce.sbu.ac.ir>
 * Bahman Radjabalipoor<b-radjabalipoor@ce.sbu.ac.ir>
 * Computer Department
 * Shahid Beheshti University
*/

#ifndef __NETWORK_PARAMS_H
#define __NETWORK_PARAMS_H

#include "NetHeader.h"

class TNetworkParams
{
private:
    float fGama;
    float fDelta;
    float fBeta;
    float fMu;
    float fK;

protected:
    TNetworkParams() {
	SetGama();	
        SetDelta();	
        SetBeta();	
        SetMu();		
        SetK();		
    }
    TNetworkParams(const TNetworkParams& p) {
        SetGama( p.fGama );
        SetDelta( fDelta );
        SetBeta( p.fBeta );
        SetMu( p.fMu );
        SetK( p.fK );
    }

    inline void SetGama(const float& val = DEFAULT_GAMA) { fGama = val; }
    inline void SetDelta(const float& val = DEFAULT_DELTA) { fDelta = val; }
    inline void SetBeta(const float& val = DEFAULT_BETA) { fBeta = val; }
    inline void SetMu(const float& val = DEFAULT_MU) { fMu = val; }
    inline void SetK(const float& val = DEFAULT_K) { fK = val; }
	
    inline float GetGama() const { return fGama; }
    inline float GetDelta() const { return fDelta; }
    inline float GetBeta() const { return fBeta; }
    inline float GetMu() const { return fMu; }
    inline float GetK()	const { return fK; }
};

#endif // __NETWORK_PARAMS_H